/*
 * Copyright (c) 2018. Developed by Hedgecode.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.hedgecode.chess.dto;

import java.math.BigInteger;
import java.util.Date;

import org.hedgecode.chess.domain.Author;
import org.hedgecode.chess.domain.EtudeAdapter;
import org.hedgecode.chess.domain.EtudeType;

/**
 *
 *
 * @author Dmitry Samoshin aka gotty
 */
public class EtudeDTOAdapter implements EtudeAdapter<EtudeDTO> {

    @Override
    public Class<EtudeDTO> getTargetClass() {
        return EtudeDTO.class;
    }

    @Override
    public void setId(EtudeDTO target, Long id) {
        target.setId(id);
    }

    @Override
    public void setHash(EtudeDTO target, BigInteger hash) {
        target.setHash(hash);
    }

    @Override
    public void setName(EtudeDTO target, String name) {
        target.setName(name);
    }

    @Override
    public void setEtudeType(EtudeDTO target, EtudeType etudeType) {
/* todo
        target.setEtudeTypeId(etudeType.getId());
*/
    }

    @Override
    public void setAuthor(EtudeDTO target, Author author) {
/* todo
        target.setAuthorId(author.getId());
*/
    }

    @Override
    public void setAuthorName(EtudeDTO target, String authorName) {
        target.setAuthorName(authorName);
    }

    @Override
    public void setFen(EtudeDTO target, String fen) {
        target.setFen(fen);
    }

    @Override
    public void setPgn(EtudeDTO target, String pgn) {
        target.setPgn(pgn);
    }

    @Override
    public void setBlob(EtudeDTO target, byte[] blob) {
        target.setBlob(blob);
    }

    @Override
    public void setDate(EtudeDTO target, Date date) {
        target.setDate(date);
    }

    @Override
    public void setDescription(EtudeDTO target, String description) {
        target.setDescription(description);
    }

}
