/*
 * Copyright (c) 2018. Developed by Hedgecode.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.hedgecode.chess.service;

import java.util.ResourceBundle;

import org.hedgecode.chess.EtudeConstants;

/**
 * Service Provider Interface (SPI) Registry Exception.
 *
 * @author Dmitry Samoshin aka gotty
 */
public class ServiceRegistryException extends RuntimeException {

    private static final ResourceBundle LOCALE_BUNDLE =
            ResourceBundle.getBundle(EtudeConstants.SERVICE_BUNDLE_FILE);

    public ServiceRegistryException(String localeKey) {
        super(
                LOCALE_BUNDLE.getString(localeKey)
        );
    }

    public ServiceRegistryException(String localeKey, Object... parameters) {
        super(
                String.format(
                        LOCALE_BUNDLE.getString(localeKey), parameters
                )
        );
    }

}
